## murahatebu : progress.rb

require 'ttrl/matching_list.rb'
require 'ttrl/text_template.rb'

require 'base.rb'

## вɽ
MuraHatebu::PROGRESS_ENTRY_DISPLAY_COUNT = 100

## вΥե̾
MuraHatebu::PROGRESS_FILENAME = 'progress.html'


module MuraHatebu
  ## -- ProgressManager --------------------------------------------------
  class ProgressManager
    def get_progress_point( entry )
      return -1 if @black_list.match( entry.target_url )
      # return -1 if entry.bookmarks.size < CHOSEN_ENTRY_VILLAGERS_THRESHOLD
      result = 0
      entry.bookmarks.each{|bookmark|
        case bookmark.time.to_date
        when TODAY
          result += 3
        when TODAY - 1
          result -= 1
        when TODAY - 2
          result -= 1
        end
      }
      result
    end

    ## -- в html ե
    def make_progress_html
      entry_count = 0
      @daily_template.reset

      @collected_daily_data.entry_hash.values.sort_by{|entry| [self.get_progress_point( entry ), entry.bookmarks.first.time]
      }.reverse_each{|entry|
        progress_point = self.get_progress_point( entry )

        @daily_template.add_one_row( entry_count + 1, entry, progress_point )

        entry_count += 1
        break if entry_count >= PROGRESS_ENTRY_DISPLAY_COUNT
      }

      ## -- ƥץ졼Ȥ
      @daily_template.params.date = Util.enc( TODAY.to_japanese_string )
      @daily_template.params.type = Util.enc( 'в ' + Time.now.strftime( '%H:%M:%S' ) )
      @daily_template.params.version = VERSION
      daily_html = @daily_template.make_text
      daily_html.gsub!( /\"\.\.\//, "\"./" )
      Util.file_puts( Util.filename_to_path( PROGRESS_FILENAME ), "w", daily_html )
    end

    ## -- ᥤ -----
    def start
      ## -- ƼǡѰ
      @villagers = {}
      Util.load_village_people_file {|name|
        @villagers[name] = Villager.new( name )
      }
      @collected_daily_data = CollectedDailyData.new( @villagers )
      @black_list = TTRL::MatchingList.new
      BlackList::FILENAMES.each{|filename|
        @black_list.read_file( Util.filename_to_path( filename ) )
      }

      @daily_template = DailyTemplate.new

      ## -- 1 ʬǡؿ
      load_cache_or_get_data = lambda{|date|
        daily_data = DailyData.new( date )
        daily_data.raise_if_cache_not_exist
        daily_data.load_cache
        @collected_daily_data.add_daily_data( daily_data )
      }

      ## -- ѥǡ -----
      YESTADAY.step( YESTADAY - 1, -1 ) {|date|
        load_cache_or_get_data.call( date )
      }

      today_data = DailyData.new( TODAY )
      today_data.get_data( @villagers )
      @collected_daily_data.add_daily_data( today_data )

      ## -- в html ե
      self.make_progress_html
    end
  end
end

## -- main ---------------------------------------------------------------
if $0 == __FILE__
  MuraHatebu::TODAY = Date.parse( ARGV[0] ) rescue Date.today
  MuraHatebu::YESTADAY = MuraHatebu::TODAY - 1
  MuraHatebu::ProgressManager.new.start
end
