#! /usr/local/bin/ruby
## tt web analyze : ssi.rb


Dir.chdir( File.dirname( __FILE__ ) ) {
  require 'ttrl/ssi_portal.rb'
  require 'ttrl/utility.rb'
  require 'ttrl/schedule_executor.rb'

  require 'base.rb'
  require 'analyzer.rb'
  require 'index_maker.rb'
}


portal = TTRL::SSIPortal.new
portal.remove_request_method = true
portal.change_stdout_to_null = true
portal.start {
  ## -- make pages
  today           = Time.now.to_date
  yestaday        = today - 1

  analyzer = TtWebAnalyze::Analyzer.new( today )
  analyzer.write_to_file( TTRL::Utility.filename_to_path( 'archives/today.html' ) )

  executor = TTRL::ScheduleExecutor.new( TTRL::Utility.filename_to_path( 'lastdate' ) )
  executor.execute_once_a_day {|last_access|
    ## -- archives
    yestaday.step( last_access.to_date, -1 ) {|date|
      analyzer = TtWebAnalyze::Analyzer.new( date )
      break unless analyzer.cache_exist?
      analyzer.write_to_date_file
    }

    ## -- index.shtml
    TtWebAnalyze::IndexMaker.make

    true
  }
}
## no wait

print '<!-- Tt Web Analyze SSI -->'
